const std = @import("std");
const tolmac = @import("tolmac.zig");

fn printInt(int: u64, other: u32, another: u16) callconv(.SysV) void {
    @setAlignStack(16);
    std.debug.print("test: {}, {}, {}\n", .{ int, other, another });
}

const opPrintIntZov = tolmac.generateOpZovSysvFromPrototype(printInt) catch unreachable;

pub fn main() !void {
    // todo: Mixing return addresses in stack poses a challenge, hm.
    const add = [_]tolmac.Word{
        @as(tolmac.Word, @intFromPtr(&tolmac.opSumWordsWithOverflow)),
        @as(tolmac.Word, @intFromPtr(&tolmac.opReturn)),
    };

    const entry = [_]tolmac.Word{
        @as(tolmac.Word, @intFromPtr(&tolmac.opPushWord)),
        1,
        @as(tolmac.Word, @intFromPtr(&tolmac.opPushWord)),
        2,
        @as(tolmac.Word, @intFromPtr(&tolmac.opCall)),
        @as(tolmac.Word, @intFromPtr(&add)),
        @as(tolmac.Word, @intFromPtr(&tolmac.opSinkWord)),
        @as(tolmac.Word, @intFromPtr(&tolmac.opPushWord)),
        10,
        @as(tolmac.Word, @intFromPtr(&tolmac.opPushWord)),
        20,
        @as(tolmac.Word, @intFromPtr(opPrintIntZov)),
        @as(tolmac.Word, @intFromPtr(&printInt)),
        @as(tolmac.Word, @intFromPtr(&tolmac.opSinkWord)),
        @as(tolmac.Word, @intFromPtr(&tolmac.opSinkWord)),
        @as(tolmac.Word, @intFromPtr(&tolmac.opSinkWord)),
        @as(tolmac.Word, @intFromPtr(&tolmac.opReturn)),
    };

    tolmac.execute(&entry, 0);
}
